<?php
/*
Plugin Name: Storyscraper.io
Plugin URI: https://storyscraper.io
Description: Official wordpress plugin of Storyscraper.io, It helps to connect storyscraper.io server.
Version: 1.1
Author: Storyscraper.io
Author URI: https://storyscraper.io
*/


/**
 * Generates a new application password for the current user
 */





function nimay_login_form() {
    global $current_user;
    wp_get_current_user();
    $site_url = get_option('siteurl');
    $current_username = $current_user->user_login;
    $html = '<div style="text-align:center; margin-top: 5%">';
    $html .= '<img src="https://storyscraper.io/wp-content/uploads/2023/03/logo.png" width="15%" style="display:block; margin:auto; max-width:100%; height:auto;">';
    
    // Check if REST API is blocked or protected
    $rest_url = get_rest_url();
    $response = wp_remote_get( $rest_url );
    if ( is_wp_error( $response ) || 404 === wp_remote_retrieve_response_code( $response ) ) {
        // Show warning message
        $html .= '<p style="color: red; font-size: 20px;">Hey, REST API is disabled or protected. Please enable it by contacting your hosting provider support team.</p>';
      	echo $html;
    } else {
        // Show login form
        $html .= '<form id="nimay-login-form" action="' . esc_url(admin_url( 'admin-post.php' )) . '" method="post" style="display:inline-block;">';
        $html .= '<input type="hidden" name="action" value="nimay_login">';
        $html .= '<input type="hidden" name="site_address" value="' . esc_url($site_url) . '">';
        $html .= '<input type="hidden" name="site_username" value="' . esc_attr($current_username) . '">';
        $html .= '<p style="margin-bottom:16px;"><label for="api_key" style="display:block; font-size:16px;">Enter StoryScraper.io Username/E-mail ID</label>';
        $html .= '<input type="text" name="story_username" id="api_key" required style="padding:8px; border:1px solid #ccc; border-radius:4px; font-size:16px; width:100%; box-sizing:border-box;" value="' . esc_attr($_POST['story_username']) . '"></p>';

        $html .= '<p style="margin-bottom:16px;"><label for="api_secret" style="display:block; font-size:16px;">Enter StoryScraper.io Password</label>';
        $html .= '<input type="password" name="story_password" required id="api_secret" style="padding:8px; border:1px solid #ccc; border-radius:4px; font-size:16px; width:100%; box-sizing:border-box;" value="' . esc_attr($_POST['story_password']) . '"></p>';
        $html .= '<p style="margin-bottom:16px;"><label for="api_secret" style="display:block; font-size:16px;">Adsense Pub ID (Optional))</label>';
        $html .= '<input type="password" name="ad_pub" id="api_secret" style="padding:8px; border:1px solid #ccc; border-radius:4px; font-size:16px; width:100%; box-sizing:border-box;" value="' . esc_attr($_POST['ad_pub']) . '"></p>';
        $html .= '<p style="margin-bottom:16px;"><label for="api_secret" style="display:block; font-size:16px;">Ad Slot Code (Optional)</label>';
        $html .= '<input type="password" name="ad_slot" id="api_secret" style="padding:8px; border:1px solid #ccc; border-radius:4px; font-size:16px; width:100%; box-sizing:border-box;" value="' . esc_attr($_POST['ad_slot']) . '"></p>';
		$html .= '<p><input type="submit" value="Connect" style="padding:8px 16px; background-color:#4CAF50; color:#fff; border:none; border-radius:4px; font-size:16px;" onclick="this.value=\'Processing...\';"></p>';
        $html .= '</form>';
        $html .= '</div>';
        echo $html;
    }

}

function nimay_handle_login() {
  $user_id = get_current_user_id();
  $random_app_name = 'my-app-' . substr(md5(rand()), 0, 7); // Generate a random application name
  $app_exists = WP_Application_Passwords::application_name_exists_for_user($user_id, $random_app_name);

  if (!$app_exists) {
      $app_pass = WP_Application_Passwords::create_new_application_password($user_id, array('name' => $random_app_name));
      $new_password = $app_pass[0];
  } else {
      $new_passwordd = WP_Application_Passwords::get_application_password_by_name($user_id, $random_app_name);
    	$new_password = $new_passwordd[0];
  }
  
    $site_address = sanitize_text_field( $_POST['site_address'] );
    $site_username = sanitize_text_field( $_POST['site_username'] );
    $story_username = sanitize_text_field( $_POST['story_username'] );
    $story_password = sanitize_text_field( $_POST['story_password'] );
  	$ad_pub = sanitize_text_field( $_POST['ad_pub'] );
  	$ad_slot = sanitize_text_field( $_POST['ad_slot'] );
  
    $response = wp_remote_post( 'https://appnew.storyscraper.io/dashboard/plugin-link/', array(
        'body' => array(
            'site_address' => $site_address,
            'site_username' => $site_username,
            'site_password' => $new_password,
            'story_username' => $story_username,
            'story_password' => $story_password,
            'security_token' => "8e75525efebaa083b07c3a5a6b5bc8a60adcf255604c10caddf728b23557d8bc",
          	'ad_slot' => $ad_slot,
          	'ad_pub' => $ad_pub,
        )
    ) );

    if ( is_wp_error( $response ) ) {
        $error_message = $response->get_error_message();
        wp_die( $error_message );
    } else {
        $response_body = wp_remote_retrieve_body( $response );
        $response_data = json_decode( $response_body );

        if ( isset( $response_data->success ) && $response_data->success ) {
            // Login successful, set user meta with security token
          // Login successful, set user meta with security token, story username, and story password
          update_user_meta( get_current_user_id(), 'nimay_logged_in', true );
          update_user_meta( get_current_user_id(), 'nimay_security_token', $security_token );
          update_user_meta( get_current_user_id(), 'nimay_story_username', $story_username );
          update_user_meta( get_current_user_id(), 'nimay_story_password', $story_password );
          header('Location: ' . admin_url('admin.php?page=storyscraper-login'));
          exit;
        } else {
         // Login failed, show error message to user
        $error_message = $response_data->error_message; // retrieve error message from Django response
        echo '<p>Connection failed: ' . $error_message . '</p>'; // display error message to use
        }
    }
}




function nimay_add_admin_menu() {
    add_menu_page(
        'Storyscraper',
        'StoryScraper.io',
        'manage_options',
        'storyscraper-login',
        'nimay_login_page',
      	plugin_dir_url( __FILE__ ) . 'assets/icon.png'
    );
}

function nimay_register_admin_actions() {
    add_action( 'admin_post_nimay_login', 'nimay_handle_login' );
}


function nimay_login_page() {
    // Check if user is already logged in
    $nimay_logged_in = get_user_meta( get_current_user_id(), 'nimay_logged_in', true );
    if ( $nimay_logged_in ) {
echo '<div style="display:flex; flex-direction: column; align-items: center;">
    <!-- Lottie animation -->
    <script src="https://unpkg.com/@lottiefiles/lottie-player@latest/dist/lottie-player.js"></script>
    <lottie-player src="https://assets8.lottiefiles.com/packages/lf20_rqtv3qia.json" background="transparent" speed="1" style="width: 300px; height: 300px;" loop autoplay></lottie-player>
    <!-- Text -->
    <h2 style="text-align: center;">Your site, Has been connected with <b>StoryScraper.io</b> tool successfully!</h2>
    <br>
    <h3 style="text-align: center;">Deactivate the Plugin to Unlink site</h3>
</div>
';
        echo '<form id="nimay-unlink-form" method="post">';
echo '<div style="text-align: center">';
echo '<button type="submit" name="nimay_unlink" id="nimay-unlink-button" style="display:block; margin:auto; padding:8px 16px; background-color:red; color:white; border:none; border-radius:4px; font-size:16px;" onclick="this.innerHTML=\'Processing...\'; this.disabled=false;">Unlink</button>';
echo '</div>';
        echo '</form>';

        if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['nimay_unlink'])) {
            $story_username = get_user_meta( get_current_user_id(), 'nimay_story_username', true );
            $story_password = get_user_meta( get_current_user_id(), 'nimay_story_password', true );
            $home_url = home_url();
            $security_token = '8e75525efebaa083b07c3a5a6b5bc8a60adcf255604c10caddf728b23557d8bc';

            $post_url = 'https://appnew.storyscraper.io/dashboard/plugin-link/';

            $data = array(
                'action' => 'unlink',
                'nimay_story_username' => $story_username,
                'nimay_story_password' => $story_password,
                'site_url' => $home_url,
                'security_token' => $security_token,
            );

            $response = wp_remote_post(
                $post_url,
                array(
                    'body' => $data,
                    'timeout' => 200,
                    'httpversion' => '1.0',
                    'sslverify' => true,
                )
            );

            if (is_wp_error($response)) {
                error_log($response->get_error_message());
            } else {
                $user_id = get_current_user_id();
                $meta_key = 'nimay_logged_in';
                $meta_value = false;
                $meta_updated = update_user_meta($user_id, $meta_key, $meta_value);
                if ($meta_updated) {
                  echo '<script>alert("Site has been successfully unlinked."); location.reload();</script>';
                    exit();
                } else {
                    echo 'Failed to update user meta data.';
                }
            }
        }

    } else {
        nimay_login_form();
    }
}


 register_deactivation_hook( __FILE__, 'nimay_deactivate' );

function nimay_deactivate() {
    update_user_meta( get_current_user_id(), 'nimay_logged_in', false );
}

add_action( 'admin_menu', 'nimay_add_admin_menu' );
add_action( 'admin_init', 'nimay_register_admin_actions' );
?>
